diff --git a/execute.c b/execute.c
index 24b063a..95dd814 100644
--- a/execute.c
+++ b/execute.c
@@ -970,6 +970,12 @@ next_param_row:
 	if (ipdopts->param_status_ptr)
 		ipdopts->param_status_ptr[stmt->exec_current_row] = SQL_PARAM_ERROR;
 
+	/*
+	 *	Free any data at exec params before the statement is executed
+         *	again.
+	 */
+	SC_free_params(stmt, STMT_FREE_PARAMS_DATA_AT_EXEC_ONLY);
+
 	/*
 	 * Check if statement has any data-at-execute parameters when it is
 	 * not in SC_pre_execute.
